import android.content.Intent;
import android.os.Bundle;
import ketai.net.bluetooth.*;
import ketai.ui.*;
//import ketai.net.*;

KetaiBluetooth bt;
KetaiList klist;
ArrayList devicesDiscovered = new ArrayList();
boolean isConfiguring = true;

String recu = "";
String trame="";
String Ud="";
String Uv="";

byte cmde[] = new byte[1];  // octet de cmde vers le wagon
String Dev_Add = "";        // Adresse du peripherique connecte en BT (rempli a la chaque reception)

//********************************************************************
// Les 2 fonctions suivantes preparent le BlueTooth ( CallBacks)
//********************************************************************
void onCreate(Bundle savedInstanceState) {  // appelee a la creation du thread instancie la connexion BT
  super.onCreate(savedInstanceState);
  bt = new KetaiBluetooth(this);
}
void onActivityResult(int requestCode, int resultCode, Intent data) {
  bt.onActivityResult(requestCode, resultCode, data);
}

void onKetaiListSelection(KetaiList klist) {       // CallBack utilisant ketai.UI pour afficher la selection de peripherique disponi
  String selection = klist.getSelection();
  bt.connectToDeviceByName(selection);             // se connecte au peripherique selectionne
  klist = null;                                    // on n'a plu besoin de la liste
}

void setup_BT() {
  bt.start();                              // demarre l'instance de connexion BT
  isConfiguring = true;                    // indique a draw() qu'il doit attendre la selection du peripherique
}

void draw_BT()  {          // affiche la selection du peripherique et declenche la connexion
                           // on a besoin d'être dans le draw pour avoir un IHM actif
    background(78, 93, 75);
    klist = new KetaiList(this, bt.getPairedDeviceNames()); // recupere la liste des peripheriques du telephone
                                                            // declenche la selection par le Call Back 'onKetaiListSelection(KetaiList klist)
    isConfiguring = false; // libere le draw() principal, le BT est actif, on peut y aller
}

//------------------------ Fonction appelee quand il y a quelque chose de recu
void onBluetoothDataEvent(String who, byte[] data) {
  if (isConfiguring) {                            // tant que le peripherique n'est pas selectionne et actif, on ne fait rien
    return;
  }
  // on a recu quelque chose. trame valide : *sdddddd uu,*sddddd uuuu\n     *étant n'importe quelle chaine de caractères
  int ind;
  Dev_Add = who;                                  // adresse du dernier qui a parle  (utile pour repondre)
  recu = recu + new String(data);                 // la trame peutpré arriver en plusieurs morceaux qu'il faut remettre bout a bout
  if ((ind=recu.indexOf("\n"))==-1)  return;      // pas de trame complete recue (detection \n) on attend la suite de la trame
  trame = recu.substring(0,ind);                  // trame complete, prete pour extraire distance, Ud, vitesse, Uv
  recu=recu.substring(ind+1);                     // on retire la trame du buffer de reception y compris le \n
  if ((ind=trame.indexOf(","))==-1)  return;      // il n'y a pas de virgule dans la trame, on refuse la trame
  if (ind>9) {                                    // la trame contient assez de caracteres pour decoder la distance
    // tmp =trame.substring(ind-9,ind-2);         // debug: la chaine de la distance
    distance = Integer.parseInt(trim(trame.substring(ind-9,ind-2)));       // valeur de la distance
    Ud = trame.substring(ind-2,ind);              // le nom de l'unite
  }
  ind=trame.length();                             // on recupere la vitesse a la fin de la trame
  if (ind>11) {                                   // la trame contient assez de caracteres pour decoder la vitesse
    //tmp = trame.substring(ind-10,ind-4);        // debug: la chaine de la vitesse          
    vitesse = Integer.parseInt(trim(trame.substring(ind-10,ind-4)));        // valeur de la vitesse
    Uv = trame.substring(ind-4,ind);              // le nom de l'unite
   }
}

void envoi_octet(byte x) {      // envoi d'un octet
  cmde[0]=x;                    // bt.write attent un pointeur sur un byte
  bt.write(Dev_Add,cmde);
}
