/*  Affichage bodometre Wagon
    Reception BT
    Boutons cmdes Wagon
*/

PImage cadran;                  // image de fond du cadran a lire dans ./data
PImage aiguille_r, aiguille_v;  // image des aiguilles a lire dans ./data
PImage titre;                   // image pour le titre
PFont fontDist;                 // font utilisee pour la distance (ici ce sera 7 segments)
PFont fontUnits;                // font pour les unites sur le cadran
PFont fontInfo;                 // font pour l'affichage de la trame reçue et autre infos de debug
int Tx, Ty;                     // position texte distance  segments
int P0, P180;                   // angles min et max de l'aiguille (dans l'image, l'aiguille est à -135°)
int WinLarg = 1080;             // Largeur de la fenetre  &  WinHaut = taille de l'image
int WinHaut = 1920;             // Hauteur de la fenetre
int distance, vitesse;          // valeurs numeriques recues a afficher


void settings() {
//  size (WinLarg,WinHaut,OPENGL);    // preparation de la fenetre

  size(displayWidth, displayHeight);
  WinLarg = displayWidth;
  WinHaut = displayHeight;
}

void setup() {
    orientation(PORTRAIT);
    background(0);
    // chargement des images utiles
    cadran = loadImage("Cadran.png");                    // image du fond
    aiguille_r = loadImage("Aiguille_rouge.png");        // image de l'aiguille rouge
    aiguille_v = loadImage("Aiguille_verte.png");        // image de l'aiguille verte
    titre = loadImage("Wagon.png");                      // image de titre
    Tx=216;  Ty=-140;                                    // position du texte pour les 7-segments de la distance
    P0=-49;  P180=225;                                   // angles de l'aiguille pour une vitesse de 0 et de 180
        // les aiguilles sont a peu pres  a -135° dans leur image. il faut tourner l'image de 49° pour avoir une aiguille verticale (a 0)
        // il faut tourner l'image de 225° pour avoir un aiguille horizontale (a 180)
    imageMode(CENTER);                                   // images referencees par leur centre

    fontDist = createFont("DSEG7Classic-BoldItalic.ttf", 70); // pour l'affichage de la distance on utilise 7 segments de taille 40
    fontUnits = createFont("arialbd.ttf",60);            // pour l'affichage des unites, on utilise Arial gras de taille 35
    fontInfo = createFont("SansSerif", 40);              // pour les messages voire le debug
    textAlign(RIGHT);                                    // Alignement du texte à droite
 
 // Décommenter les 2 lignes suivantes pour voir la liste des fonts disponibles
 // String[] fontList = PFont.list();
 //  printArray(fontList);
 
   setup_BT();                                           // init bluetooth  
   setup_boutons();                                      // init des boutons
}


void draw() {

  if (isConfiguring) {   // au depart l'application cherche à se connecter en BT, il ne faut pas que nos graphiques interfererent
    draw_BT();           // appel du draw specifique a l'init du BlueTooth                   
    return;
  }
  
  
  
  float angle;                                           // variable locale pour l'angle de l'aiguille
    if ((mousePressed) && (mouseY >1600)) {              // pour debug, genere une vitesse et un distance f(position click)
      vitesse = int(map(mouseX, 50,width-50,-180,180));  // convertion position souris en vitesse
      distance = int(map(mouseY, 200,height,100000,0));  // convertion position souris en valeur affichee
    }
    background(65,160,146);
    stroke(177);                                         // Couleur des traits
    translate(WinLarg/2, WinHaut/2);                     // place la reference pour le cadran au centre de la fenetre
    pushMatrix();
    textFont(fontUnits);
    fill(0);
    image(titre, 300, -790, 400,300);
    textSize(100);
    text("WAGON",20,-800);
    text("ODOMETRE",100,-700);
    image(cadran, 0 , 0 , WinLarg , WinLarg);            // image du fond (cadran) centree en 0,0 et etendue à toute la fenetre
    textFont(fontUnits);                                 // pour les unites
    fill(220,220,220);                                   // couleur grise
    text(Ud, 280,-80);                                   // ecriture de la chaine unite de distance
    text(Uv, 320, 200);                                  // ecriture de la chaine unite de vitesse
    
    textFont(fontDist);                                  // pour la distance
    fill(20,20,20);                                      // selection de la couleur noire
    rect(Tx-400,Ty-80,400,90);                           // rectangle noir de fond pour les 7 segments
    fill(65,65,0);                                       // selection de la couleur jaune foncee
    text("-888888",Tx,Ty);                               // appercu des segments eteints en jaune fonce
    fill(250,250,0);                                     // selection de la couleur jaune pour les segments allumes
    text(distance, Tx,Ty);                               // ecriture distance dans le rectangle
    if (vitesse <0) {                                    // la vitesse doit etre >0 sinon on change la couleur de l'aiguille
      angle = map(-vitesse, 0,180,P0,P180);              // convertion abs(vitesse) en angle aiguille
      rotate(radians(angle));                            // rotation de la reference avant de dessiner l'aiguille
      image(aiguille_r, -90,90, WinLarg*0.35 , WinLarg*0.35); // dessin de l'aiguille rouge (vitesse negative)
                                                              // avec un offset pour retrouver le centre de l'aiguille dans l'image
                                                              // et une augmentation de taille pour correspondre au cadran
    }
    else  {
      angle = map(vitesse, 0,180,P0,P180);               // convertion vitesse en angle aiguille
      rotate(radians(angle));                            // rotation de la reference avant de dessiner l'aiguille
      image(aiguille_v, -90,90, WinLarg*0.35 , WinLarg*0.35); // dessin de l'aiguille verte (vitesse positive)
                                                              // avec un offset pour retrouver le centre de l'aiguille dans l'image
                                                              // et une augmentation de taille pour correspondre au cadran
    }                                                          
    popMatrix();                                         // revient à la geometrie sans la rotation
    
    fill (0);                                            // selection de la couleur noire
    textFont(fontInfo);                                  // selection de la police
    text(trame,400,800);                                 // affichage de la trame reçue pour verification
	
	// ajouter ici d'autres affichages pour debug, si besoin

    draw_boutons();                                       // dessin et gestion des boutons                                       
}
